/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.gtask.data;

import android.database.Cursor;
import android.util.Log;

import net.micode.notes.data.Notes;
import net.micode.notes.data.Notes.NoteColumns;
import net.micode.notes.gtask.exception.ActionFailureException;
import net.micode.notes.tool.GTaskStringUtils;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;

//定义了一个名为TaskList的类，并继承自Node类
public class TaskList extends Node {
	//定义了一个名为TAG的静态字符串变量，用于在日志中标记该类
    private static final String TAG = TaskList.class.getSimpleName();
//定义了一个名为mIndex的整型变量，用于表示任务列表的索引
    private int mIndex;
//定义了一个名为mChildren的Task类型的ArrayList变量，用于存储该任务列表的子任务。
    private ArrayList<Task> mChildren;
//定义了一个无参构造函数，初始化了mChildren变量和mIndex变量
    public TaskList() {
        super();
        mChildren = new ArrayList<Task>();
        mIndex = 1;
    }
   /* 定义了一个名为getCreateAction的方法，该方法返回一个JSONObject对象，用于表示任务列表的创建动作。
    该方法需要传入一个actionId参数，用于标识该动作。在方法中，首先创建了一个名为js的空的JSONObject对象。
    然后，该方法按照特定的格式设置了js对象的各个字段，如action_type、action_id、index和entity_delta等。
    其中，entity_delta字段包含了一些有关任务列表的具体信息，如name、creator_id和entity_type等。
    如果在设置js对象的过程中发生了异常，则该方法将抛出一个ActionFailureException异常。最后，该方法返回了生成的js对象。
    */
    public JSONObject getCreateAction(int actionId) {
        JSONObject js = new JSONObject();

        try {
            // action_type
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_TYPE,
                    GTaskStringUtils.GTASK_JSON_ACTION_TYPE_CREATE);

            // action_id
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_ID, actionId);

            // index
            js.put(GTaskStringUtils.GTASK_JSON_INDEX, mIndex);

            // entity_delta
            JSONObject entity = new JSONObject();
            entity.put(GTaskStringUtils.GTASK_JSON_NAME, getName());
            entity.put(GTaskStringUtils.GTASK_JSON_CREATOR_ID, "null");
            entity.put(GTaskStringUtils.GTASK_JSON_ENTITY_TYPE,
                    GTaskStringUtils.GTASK_JSON_TYPE_GROUP);
            js.put(GTaskStringUtils.GTASK_JSON_ENTITY_DELTA, entity);

        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            throw new ActionFailureException("fail to generate tasklist-create jsonobject");
        }

        return js;
    }

    public JSONObject getUpdateAction(int actionId) {
        JSONObject js = new JSONObject();

        try {
            // action_type
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_TYPE,
                    GTaskStringUtils.GTASK_JSON_ACTION_TYPE_UPDATE);

            // action_id
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_ID, actionId);

            // id
            js.put(GTaskStringUtils.GTASK_JSON_ID, getGid());

            // entity_delta
            JSONObject entity = new JSONObject();
            entity.put(GTaskStringUtils.GTASK_JSON_NAME, getName());
            entity.put(GTaskStringUtils.GTASK_JSON_DELETED, getDeleted());
            js.put(GTaskStringUtils.GTASK_JSON_ENTITY_DELTA, entity);

        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            throw new ActionFailureException("fail to generate tasklist-update jsonobject");
        }

        return js;
    }

    public void setContentByRemoteJSON(JSONObject js) {
        if (js != null) {
            try {
                // id
                if (js.has(GTaskStringUtils.GTASK_JSON_ID)) {
                    setGid(js.getString(GTaskStringUtils.GTASK_JSON_ID));
                }

                // last_modified
                if (js.has(GTaskStringUtils.GTASK_JSON_LAST_MODIFIED)) {
                    setLastModified(js.getLong(GTaskStringUtils.GTASK_JSON_LAST_MODIFIED));
                }

                // name
                if (js.has(GTaskStringUtils.GTASK_JSON_NAME)) {
                    setName(js.getString(GTaskStringUtils.GTASK_JSON_NAME));
                }

            } catch (JSONException e) {
                Log.e(TAG, e.toString());
                e.printStackTrace();
                throw new ActionFailureException("fail to get tasklist content from jsonobject");
            }
        }
    }
/*setContentByLocalJSON(JSONObject js)方法根据传入的本地JSON数据来设置任务列表的内容。
    首先判断传入的JSON对象是否为空或者不包含GTaskStringUtils.META_HEAD_NOTE，如果是，则记录一个警告日志。
    如果不是，则从JSON对象中获取名为GTaskStringUtils.META_HEAD_NOTE的JSONObject。
    判断该JSONObject中的NoteColumns.TYPE字段的值是否为Notes.TYPE_FOLDER，如果是，
    则从NoteColumns.SNIPPET字段中获取任务列表的名称并通过setName()方法来设置任务列表的名称；
    如果该字段的值为Notes.TYPE_SYSTEM，则进一步判断其NoteColumns.ID字段的值，如果其值为Notes.ID_ROOT_FOLDER，
    则设置任务列表的名称为默认名称，如果其值为Notes.ID_CALL_RECORD_FOLDER，则设置任务列表的名称为通话笔记的名称。
    如果该字段的值不是上述两种情况，则记录一个错误日志。如果在处理过程中出现异常，则记录一个错误日志并打印异常信息。
 */   
    public void setContentByLocalJSON(JSONObject js) {
        if (js == null || !js.has(GTaskStringUtils.META_HEAD_NOTE)) {
            Log.w(TAG, "setContentByLocalJSON: nothing is avaiable");
        }

        try {
            JSONObject folder = js.getJSONObject(GTaskStringUtils.META_HEAD_NOTE);

            if (folder.getInt(NoteColumns.TYPE) == Notes.TYPE_FOLDER) {
                String name = folder.getString(NoteColumns.SNIPPET);
                setName(GTaskStringUtils.MIUI_FOLDER_PREFFIX + name);
            } else if (folder.getInt(NoteColumns.TYPE) == Notes.TYPE_SYSTEM) {
                if (folder.getLong(NoteColumns.ID) == Notes.ID_ROOT_FOLDER)
                    setName(GTaskStringUtils.MIUI_FOLDER_PREFFIX + GTaskStringUtils.FOLDER_DEFAULT);
                else if (folder.getLong(NoteColumns.ID) == Notes.ID_CALL_RECORD_FOLDER)
                    setName(GTaskStringUtils.MIUI_FOLDER_PREFFIX
                            + GTaskStringUtils.FOLDER_CALL_NOTE);
                else
                    Log.e(TAG, "invalid system folder");
            } else {
                Log.e(TAG, "error type");
            }
        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
        }
    }
/*getLocalJSONFromContent()方法返回一个本地JSON对象。该方法首先创建一个新的JSONObject对象，并创建一个名为folder的子对象。
    然后从任务列表的名称中获取名称字符串，如果名称以GTaskStringUtils.MIUI_FOLDER_PREFFIX开头，
    则截取该字符串后面的部分作为文件夹的名称。将名称字符串设置为NoteColumns.SNIPPET字段的值，
    如果名称字符串是默认名称或者通话笔记名称，则将NoteColumns.TYPE字段的值设置为Notes.TYPE_SYSTEM，
    否则设置为Notes.TYPE_FOLDER。将folder对象设置为META_HEAD_NOTE字段的值并返回JSONObject对象。
    如果在处理过程中出现异常，则记录一个错误日志并打印异常信息。
    */
    public JSONObject getLocalJSONFromContent() {
        try {
            JSONObject js = new JSONObject();
            JSONObject folder = new JSONObject();

            String folderName = getName();
            if (getName().startsWith(GTaskStringUtils.MIUI_FOLDER_PREFFIX))
                folderName = folderName.substring(GTaskStringUtils.MIUI_FOLDER_PREFFIX.length(),
                        folderName.length());
            folder.put(NoteColumns.SNIPPET, folderName);
            if (folderName.equals(GTaskStringUtils.FOLDER_DEFAULT)
                    || folderName.equals(GTaskStringUtils.FOLDER_CALL_NOTE))
                folder.put(NoteColumns.TYPE, Notes.TYPE_SYSTEM);
            else
                folder.put(NoteColumns.TYPE, Notes.TYPE_FOLDER);

            js.put(GTaskStringUtils.META_HEAD_NOTE, folder);

            return js;
        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            return null;
        }
    }
/*getSyncAction(Cursor c)方法返回一个整型值，表示需要执行的同步操作。该方法首先判断是否存在本地更新，
    如果不存在本地更新，则判断同步ID是否等于最后修改时间。如果同步ID等于最后修改时间，则说明本地和远程都没有更新，
    返回SYNC_ACTION_NONE。如果同步ID不等于最后修改时间，则说明远程有更新，返回SYNC_ACTION_UPDATE_LOCAL。
    如果存在本地更新，则校验gtask id字段是否和本地ID一致，如果不一致，则记录一个错误日志并返回SYNC_ACTION_ERROR。
    如果gtask id和本地ID一致，则判断同步ID是否等于最后修改时间。
    如果同步ID等于最后修改时间，则说明只有本地有修改，返回SYNC_ACTION_UPDATE_REMOTE。
    如果同步ID不等于最后修改时间，则返回SYNC_ACTION_UPDATE_REMOTE。如果在处理过程中出现异常，则记录一个错误日志并打印异常信息。
    */
    public int getSyncAction(Cursor c) {
        try {
            if (c.getInt(SqlNote.LOCAL_MODIFIED_COLUMN) == 0) {
                // there is no local update
                if (c.getLong(SqlNote.SYNC_ID_COLUMN) == getLastModified()) {
                    // no update both side
                    return SYNC_ACTION_NONE;
                } else {
                    // apply remote to local
                    return SYNC_ACTION_UPDATE_LOCAL;
                }
            } else {
                // validate gtask id
                if (!c.getString(SqlNote.GTASK_ID_COLUMN).equals(getGid())) {
                    Log.e(TAG, "gtask id doesn't match");
                    return SYNC_ACTION_ERROR;
                }
                if (c.getLong(SqlNote.SYNC_ID_COLUMN) == getLastModified()) {
                    // local modification only
                    return SYNC_ACTION_UPDATE_REMOTE;
                } else {
                    // for folder conflicts, just apply local modification
                    return SYNC_ACTION_UPDATE_REMOTE;
                }
            }
        } catch (Exception e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
        }

        return SYNC_ACTION_ERROR;
    }
//getChildTaskCount(): 返回子任务的数量。
    public int getChildTaskCount() {
        return mChildren.size();
    }
//addChildTask(Task task): 添加一个子任务。如果任务不为null且不在子任务列表中，则添加到列表中，并设置前一个兄弟和父任务。
    public boolean addChildTask(Task task) {
        boolean ret = false;
        if (task != null && !mChildren.contains(task)) {
            ret = mChildren.add(task);
            if (ret) {
                // need to set prior sibling and parent
                task.setPriorSibling(mChildren.isEmpty() ? null : mChildren
                        .get(mChildren.size() - 1));
                task.setParent(this);
            }
        }
        return ret;
    }
//添加一个子任务到特定的位置。如果位置无效，则返回false。如果任务不为null且不在子任务列表中，则添加到列表中并设置前一个
    public boolean addChildTask(Task task, int index) {
        if (index < 0 || index > mChildren.size()) {
            Log.e(TAG, "add child task: invalid index");
            return false;
        }

        int pos = mChildren.indexOf(task);
        if (task != null && pos == -1) {
            mChildren.add(index, task);

            // update the task list
            Task preTask = null;
            Task afterTask = null;
            if (index != 0)
                preTask = mChildren.get(index - 1);
            if (index != mChildren.size() - 1)
                afterTask = mChildren.get(index + 1);

            task.setPriorSibling(preTask);
            if (afterTask != null)
                afterTask.setPriorSibling(task);
        }

        return true;
    }
//从子任务列表中移除一个任务。如果任务不在列表中，则返回false。否则从列表中移除任务，并重置前一个兄弟和父任务。如果任务后面有其他任务，则将它们的前一个兄弟设置为它的前一个兄弟。
    public boolean removeChildTask(Task task) {
        boolean ret = false;
        int index = mChildren.indexOf(task);
        if (index != -1) {
            ret = mChildren.remove(task);

            if (ret) {
                // reset prior sibling and parent
                task.setPriorSibling(null);
                task.setParent(null);

                // update the task list
                if (index != mChildren.size()) {
                    mChildren.get(index).setPriorSibling(
                            index == 0 ? null : mChildren.get(index - 1));
                }
            }
        }
        return ret;
    }
   // 移动一个任务到一个新的位置。如果索引无效，则返回false。如果任务不在列表中，则返回false。如果任务已经在目标位置，则返回true。否则，将任务从当前位置移除，并添加到新位置。
    public boolean moveChildTask(Task task, int index) {

        if (index < 0 || index >= mChildren.size()) {
            Log.e(TAG, "move child task: invalid index");
            return false;
        }

        int pos = mChildren.indexOf(task);
        if (pos == -1) {
            Log.e(TAG, "move child task: the task should in the list");
            return false;
        }

        if (pos == index)
            return true;
        return (removeChildTask(task) && addChildTask(task, index));
    }
//根据GID查找一个子任务。如果找到则返回该任务，否则返回null。
    public Task findChildTaskByGid(String gid) {
        for (int i = 0; i < mChildren.size(); i++) {
            Task t = mChildren.get(i);
            if (t.getGid().equals(gid)) {
                return t;
            }
        }
        return null;
    }
//获取一个任务的索引。如果任务不在列表中，则返回-1。
    public int getChildTaskIndex(Task task) {
        return mChildren.indexOf(task);
    }
//根据索引获取一个任务。如果索引无效，则返回null。
    public Task getChildTaskByIndex(int index) {
        if (index < 0 || index >= mChildren.size()) {
            Log.e(TAG, "getTaskByIndex: invalid index");
            return null;
        }
        return mChildren.get(index);
    }
//根据GID获取一个任务。如果找到则返回该任务，否则返回null。
    public Task getChilTaskByGid(String gid) {
        for (Task task : mChildren) {
            if (task.getGid().equals(gid))
                return task;
        }
        return null;
    }
//获取子任务列表。
    public ArrayList<Task> getChildTaskList() {
        return this.mChildren;
    }
//设置任务的索引
    public void setIndex(int index) {
        this.mIndex = index;
    }
//设置任务的索引
    public int getIndex() {
        return this.mIndex;
    }
}
